<template>
  <div class="storage-tree row">
    <div class="tree col-12 col-sm-6 col-md-4 my-3">
      <div v-if="kexMode" class="col-12 list-group">
        <a
          v-for="kex in kexes"
          :href="`${base_url}storage/${kex}`"
          :class="`list-group-item list-group-action list-group-item-kex ${
            countTables(kex) ? '' : 'empty'
          } ${selectedKex === kex ? 'active' : ''}`"
          :data-tables="countTables(kex)"
          :key="kex"
          @click.prevent="selectKex(kex)"
          >{{ kex }}
          <span v-if="countTables(kex)" class="badge bg-success"
            >{{ countTables(kex) }} tables</span
          >
        </a>
      </div>
      <div v-if="!kexMode" class="col-12 list-group list-group-tables">
        <a
          :href="`${base_url}storage/`"
          class="list-group-item list-group-action list-group-action-back"
          @click.prevent="selectKex(selectedKex)"
          >&lt;</a
        >
        <a
          v-for="table in tree[selectedKex]"
          :key="`${selectedKex}.${table.table}`"
          @click.prevent="selectTable(selectedKex, table.table)"
          :href="`${base_url}storage/${selectedKex}/${table.table}`"
          :class="`list-group-item list-group-action ${
            selectedTable === table.table ? 'active' : ''
          }`"
          >{{ table.table }}</a
        >
      </div>
    </div>
    <div class="col-12 col-sm-6 col-md-8 my-3">
      <keep-alive>
        <kex-details
          v-if="selectedKex !== null && selectedTable === null"
          :kex="selectedKex"
          :key="selectedKex"
          @refreshRequested="refreshTables"
        />
      </keep-alive>
      <keep-alive>
        <table-details
          v-if="selectedKex !== null && selectedTable !== null"
          :kex="selectedKex"
          :table="selectedTable"
          :key="`${selectedKex}.${selectedTable}`"
      /></keep-alive>
      <template v-if="selectedKex === null && selectedTable === null">
        <p>
          <button class="btn btn-secondary" type="button" @click="refreshKexes">
            <i class="fas fa-sync"></i> Refresh list of kexes
          </button>
        </p>
        <p>Start by selecting a kex.</p></template
      >
    </div>
    <api-data
      :endpoint="`/storage/tree?public=${this.public}`"
      :key="this.public"
      ref="kexLister"
      v-model="tree"
    />
  </div>
</template>

<script>
import KexDetails from "@/components/KexDetails";
import TableDetails from "@/components/TableDetails";

export default {
  name: "StorageTree",
  components: { KexDetails, TableDetails },
  data() {
    const selectedKex = this.$route.params.kex || null;
    const selectedTable = selectedKex ? this.$route.params.table || null : null;
    return {
      tree: {},
      selectedKex,
      selectedTable,
    };
  },
  props: {
    public: {
      type: Boolean,
      default: false,
    },
  },
  inject: ["refreshStorage", "toggleProgressSpinner"],
  provide() {
    return {
      reloadStorageView: this.reloadStorageView,
    };
  },
  methods: {
    reloadStorageView(kex, table) {
      this.toggleProgressSpinner(true);
      kex = kex || null;
      table = table || null;
      this.$refs.kexLister.load();
      this.selectedKex = null;
      this.selectedTable = null;
      this.pushState("storage", [], "Storage");
      if (table) this.selectTable(kex, table);
      else if (kex) this.selectKex(kex);
      this.toggleProgressSpinner(false);
    },
    refreshTables(kex) {
      this.toggleProgressSpinner(true);
      this.refreshStorage({
        root: false,
        kex,
        finishedHandler: () => {
          this.notify("Tables were refreshed", "Task Finished", "success");
          this.reloadStorageView();
          this.toggleProgressSpinner(false);
        },
      });
    },
    refreshKexes() {
      this.toggleProgressSpinner(true);
      this.refreshStorage({
        root: true,
        finishedHandler: () => {
          this.notify("Kexes were refreshed", "Task Finished", "success");
          this.reloadStorageView();
          this.toggleProgressSpinner(false);
        },
      });
    },
    countTables(kex) {
      return this.tree[kex].length;
    },
    selectKex(kex) {
      if (this.selectedKex === kex) this.selectedKex = null;
      else this.selectedKex = kex;
      this.selectedTable = null;
      this.pushState(
        "storage",
        [this.selectedKex],
        `Storage - Kex ${this.selectedKex}`
      );
    },
    selectTable(kex, table) {
      this.selectedKex = kex;
      if (this.selectedTable === table) this.selectedTable = null;
      else this.selectedTable = table;
      this.pushState(
        "storage",
        [this.selectedKex, this.selectedTable],
        `Storage - Table ${this.selectedTable}`
      );
    },
  },
  computed: {
    kexes() {
      return Object.keys(this.tree);
    },
    kexMode() {
      return (
        this.selectedKex === null || this.tree[this.selectedKex]?.length === 0
      );
    },
  },
};
</script>

<style lang="scss">
.list-group-item-kex {
  position: relative;
  .badge {
    position: absolute;
    right: 2rem;
  }
  &:not(.empty)::after {
    display: inline-block;
    content: ">";
    right: 1rem;
    position: absolute;
    transform: rotate(0deg);
    transition: transform 250ms ease-in-out;
  }
  &:hover:not(.empty)::after {
    transform: rotate(360deg);
  }
}
</style>
